using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.IO;

namespace BYOJeopardy_win
{
    public class JData
    {
        public ArrayList topics = new ArrayList();
        public JData()
        {
        }
        public bool OpenFile(string FileName)
        {
            try
            {
                topics.Clear();
                //Open File
                StreamReader JeopardyFile = new StreamReader(FileName);
                string Line = JeopardyFile.ReadLine();
                if (!(Line == null))
                {
                    do
                    {
                        //ADD TOPICS
                        JTopic newtopic = new JTopic();
                        newtopic.TopicName = Line;
                        //ADD Values;Questions;Answers
                        Line = JeopardyFile.ReadLine();
                        if (!(Line == null))
                        {
                            do
                            {
                                string[] LineArray = Line.Split(Convert.ToChar(";"));
                                if (LineArray.Length > 1)
                                {
                                    newtopic.Values.Add(LineArray[0].ToString());
                                    newtopic.Questions.Add(LineArray[1].ToString());
                                    newtopic.Answers.Add(LineArray[2].ToString());
                                }
                                else
                                {
                                    goto EndTopic;
                                }
                                Line = JeopardyFile.ReadLine();
                            } while (!(Line == null));
                        }
                    EndTopic: ;
                        topics.Add(newtopic);
                    } while (!(Line == null));
                }
                JeopardyFile.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: opening file..." + e.Message);
                return false;
            }
            return true;
        }

        public bool SaveJeopardy(string FileName)
        {
            try
            {
                StreamWriter JeopardyFile = new StreamWriter(FileName);
                for (int t = 0; t < topics.Count; t++)
                {
                    JTopic topic = (JTopic)topics[t];
                    JeopardyFile.WriteLine(topic.TopicName);
                    for (int v = 0; v < topic.Values.Count; v++)
                    {
                        string Value = topic.Values[v].ToString();
                        string Question = "";
                        string Answer = "";
                        if (topic.Questions.Count > v)
                        {
                            Question = topic.Questions[v].ToString();
                        }
                        if (topic.Answers.Count > v)
                        {
                            Answer = topic.Answers[v].ToString();
                        }
                        JeopardyFile.WriteLine(Value + ";" + Question + ";" + Answer);
                    }
                }
                JeopardyFile.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine("Error: saving file..." + e.Message);
                return false;
            }
            return true;
        }

        public void CreateJeopardy(bool Double)
        {
            int cashValue = 100;
            if (Double)
            {
                cashValue = 200;
            }

            topics.Clear();
            for (int t = 1; t < 6; t++)
            {
                JTopic topic = new JTopic();
                topic.TopicName = "Topic" + t.ToString();
                for (int v = 1; v < 6; v++)
                {
                    topic.Values.Add((v * cashValue).ToString());
                    topic.Questions.Add("Question" + (v * cashValue).ToString());
                    topic.Answers.Add("Answer" + (v * cashValue).ToString());
                }
                topics.Add(topic);
            }
        }
    }
    public class JTopic
    {
        public string TopicName = "";
        public ArrayList Values = new ArrayList();
        public ArrayList Questions = new ArrayList();
        public ArrayList Answers = new ArrayList();
    }
}
